/**************************************************************************/
/** data: febbraio 1998                                 file: as1974.c   **/
/** ......traccia esame maturit 1974................................... **/
/** ......traduce le paghe da cifre a numero di monete minimo........... **/
/** ................uso solo file TESTO................................. **/
/**************************************************************************/
#include <stdio.h>	   		               /*........................*/
#include <string.h>	   		               /*...strcpy(), strcat()...*/
#include <ctype.h>	   		               /*...isdigit()............*/
/*********************************************************************/
/*********************************************************************/
#define nome_dos_in  "paghe.txt"           /*...archivio buste paga..*/
#define nome_dos_out "monete.txt"          /*...archivio pagamenti...*/
#define FORMATO_IN   "%23s %9s\n"          /*...formato file_in......*/
#define NUM_MONETE   13                    /*...num. tagli monete....*/
#define LUNG_ANAGR	 23                    /*...dim. stringa anagraf.*/
#define LUNG_SOMMA	 9                     /*...dim. stringa somma...*/
/*********************************************************************/
/*********************************************************************/
typedef long NUMERO;				       /*...il tipo per i soldi..*/
										   /*...i tagli attuali......*/
NUMERO monete[NUM_MONETE]={100000L, 50000L, 10000L, 5000L, 2000L, \
  1000L, 500L, 200, 100L, 50L, 20L, 10L, 5L
};
struct paga{                               /*...la busta paga!.......*/
  char anagrafico[LUNG_ANAGR+1];
  char somma[LUNG_SOMMA+1];
};
struct numerario{                         /*...il pagamento!.........*/
	char anagrafico[LUNG_ANAGR+1];
  NUMERO sommalong;
	 int pezzi[NUM_MONETE];
};
typedef struct paga UNAPAGA;              /*...i tipi di dato........*/
typedef struct numerario UNNUMERARIO;
FILE *file_in, 		                      /*...file testo UNAPAGA....*/
	 *file_out;		                      /*..........UNNUMERARIO....*/
/*********************************************************************/
/*********************************************************************/
void leggi_le_paghe(void),
	 vedi_le_paghe(void),
	 calcola_tutto(void),
	 vedi_calcoli(void);
/**************************************************************************/
/**************************************************************************/
void main(void){
  leggi_le_paghe();
  vedi_le_paghe();
  calcola_tutto();
  vedi_calcoli();
}
/**************************************************************************/
/**************************************************************************/

/****************************************** input di UNAPAGA *********/
void leggi_una_paga(UNAPAGA *p){

  printf("anagrafico: ");
  gets(p->anagrafico);
  if(strlen(p->anagrafico)){
	printf("     somma: ");
	gets(p->somma);
  }
}
/***************************************** crea l'archivio paghe ****/
void leggi_le_paghe(void){
  UNAPAGA p;

  puts("Lettura dei dati anagrafici e delle paghe...");
  file_in=fopen(nome_dos_in, "wt");
  do{
	leggi_una_paga(&p);
	if(strlen(p.anagrafico) && strlen(p.somma))
	   fprintf(file_in, FORMATO_IN, p.anagrafico, p.somma);
  }while(strlen(p.anagrafico));
  fclose(file_in);
}
/***************************************** vedi archivio paghe ******/
void vedi_le_paghe(void){
  UNAPAGA p;

  puts("\nVisualizzazione dei dati anagrafici e delle paghe...");
  file_in=fopen(nome_dos_in, "rt");
  do{
	if(fscanf(file_in, FORMATO_IN, p.anagrafico, p.somma))
	  printf(FORMATO_IN, p.anagrafico, p.somma);
  }while(!feof(file_in));
  fclose(file_in);
}
/********************************** calcola le monete per somma *****/
void calcola_tagli(NUMERO somma, int pezzi[NUM_MONETE]){
  int i;

  for(i=0; i < NUM_MONETE; i++){
	pezzi[i]=(int)(somma / monete[i]);
	somma -= ((NUMERO)pezzi[i])*monete[i];
  }
}
/************************************************* "atol" adattata **/
/******** converte da stringa in long saltando gli spazi e i punti **/
/********************************************************************/
void str_to_long(char *somma, NUMERO *Somma_Long){
  int i;

  *Somma_Long=0L;
  for(i=0; i<strlen(somma); i++)
	 if(isdigit(somma[i])){
		*Somma_Long = (NUMERO)10*(*Somma_Long)+(NUMERO)(somma[i]-'0');
	 }
}
/********************************************************************/
void calcola_tutto(void){
		  int i;
	  UNAPAGA p;
  UNNUMERARIO n,
			  tot = {"", 0L, {0L,0L,0L,0L,0L,0L,0L,0L,0L,0L,0L,0L,0L}};

  file_in=fopen(nome_dos_in, "rt");
  file_out=fopen(nome_dos_out, "wt");
  do{
	if(fscanf(file_in, FORMATO_IN, p.anagrafico, p.somma)){
	  /*...sistemo n...*/
	  strcpy(n.anagrafico, p.anagrafico);
	  str_to_long(p.somma, &(n.sommalong));
	  calcola_tagli(n.sommalong, n.pezzi);
	  /*...sistemo tot...*/
	  for(i=0; i < NUM_MONETE; i++)
		tot.pezzi[i] += n.pezzi[i];
	  tot.sommalong += n.sommalong;
	  /*...scrivo n...*/
	  fprintf(file_out, "%s\n", n.anagrafico);
	  for(i=0; i < NUM_MONETE; i++)
		fprintf(file_out, "%7ld %d\n", monete[i], n.pezzi[i]);
	  fprintf(file_out, " TOTALE %ld\n", n.sommalong);
	}
  }while(!feof(file_in));

  /*...scrivo tot...*/
  fprintf(file_out, "%23s\n", "TOTALI");
  for(i=0; i < NUM_MONETE; i++)
	fprintf(file_out, "%7ld %d\n", monete[i],  tot.pezzi[i]);
  fprintf(file_out, " TOTALE %ld\n", tot.sommalong);
  fclose(file_in);
  fclose(file_out);
}
/********************************************************************/
void vedi_calcoli(void){
  char buffer[200];

  puts("\nVisualizzazione dei dati anagrafici e delle paghe con tagli in moneta...");
  file_out=fopen(nome_dos_out, "rt");
  do{
	if(fgets(buffer, 200, file_out))
	  printf("%s", buffer);
	getch();  
  }while(!feof(file_out));
  fclose(file_out);
}
/**************************************************************************/
/**************************************************************************/
/*
   fare un menu per il main()
   le fopen(), la lettura di somma, non sono protette
   il tipo long potrebbe non essere sufficiente: 1.000 operai * L. 2.000.000
   le informazioni supplementari in/out sono scarse
*/
